public class Association
{
    private String key;
    private String value;
    
    public Association( String key, String value )
    {
        this.key   = key;
        this.value = value;
    }

    public String toString()
    {
        return "[" + key + "]:[" + value + "]";
    }

    public boolean keyContains( String pattern )
    {
        return ( key.indexOf( pattern ) != -1 );
    }
    
    public boolean valueContains( String pattern )
    {
        return ( value.indexOf( pattern ) != -1 );
    }
    
    public boolean contains( String pattern )
    {
        return ( keyContains( pattern ) || valueContains( pattern ) );
    }

    public boolean hasKey( String pattern )
    {
        return key.equals( pattern );
    }

    public boolean equals( Object obj )
    {
        if (! ( obj instanceof Association ) )
            return false;

        Association assoc = (Association) obj;
        return ( key.equals( assoc.key() ) && value.equals( assoc.value() ) );
    }

    public void appendValue( String newValue )
    {
        value = value + newValue;
    }

    // --------------------------------------------------------------------

    public boolean lessThan( Association assoc )
    {
        if ( key.compareTo( assoc.key() ) < 0 )
            return true;
        if ( key.equals( assoc.key() ) &&
             (value.compareTo( assoc.value() ) < 0 ) )
            return true;
        return false;
    }

    // --------------------------------------------------------------------

    private String key()
    {
        return key;
    }

    private String value()
    {
        return value;
    }
}
